package fahrten.geg;

import java.util.HashMap;
import java.util.Map;
import java.util.Random;

public class Ort {
	
	private static final double MAX_TIME = 100;
	private static final double MAX_DEV = 0.5;
	
	private static int ortsnummer = 3;
	private static Random rand = new Random();
	
	private Map<Ort,Double> timeMap = new HashMap<>();
	private Map<Ort,Double> devMap = new HashMap<>();
	private String name;
	
	Ort(int nummer) {
		this.name = "ort" + nummer;
	}
	
	private Ort() {
		this(ortsnummer++);
	}

	public static Ort[] getBeispiel() {
		return BeispielOrt.getBeispielOrte();
	}
	
	public static Ort[] getZufaelligeOrte(int anzahl) {
		Ort[] orte = new Ort[anzahl];
		for(int i=0; i<anzahl; i++) orte[i] = new Ort();
		return orte;
	}

	public String toString() {
		return name;
	}

	double getFahrzeit(Ort andererOrt) {
		if(andererOrt == this) return 0;
		if(!timeMap.containsKey(andererOrt)) {
			timeMap.put(andererOrt, MAX_TIME*rand.nextDouble());
			devMap.put(andererOrt, MAX_DEV*rand.nextDouble());
		}
		return timeMap.get(andererOrt)*(1+devMap.get(andererOrt)*(2*rand.nextDouble()-1));
	}
	
}
